Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.cache.ehcache
Class EhCacheManagerFactoryBean

    java.lang.Object
      org.springframework.cache.ehcache.EhCacheManagerFactoryBean

All Implemented Interfaces:
  DisposableBean, FactoryBean<net.sf.ehcache.CacheManager>, InitializingBean

    public class EhCacheManagerFactoryBean

extends java.lang.Object
implements FactoryBean<net.sf.ehcache.CacheManager>, InitializingBean, DisposableBean

`FactoryBean` that exposes an EHCache `CacheManager` instance (independent or shared), configured from a specified config location.

If no config location is specified, a CacheManager will be configured from "ehcache.xml" in the root of the class path (that is, default EHCache initialization - as defined in the EHCache docs - will apply).

Setting up a separate EhCacheManagerFactoryBean is also advisable when using EhCacheFactoryBean, as it provides a (by default) independent CacheManager instance and cares for proper shutdown of the CacheManager. EhCacheManagerFactoryBean is also necessary for loading EHCache configuration from a non-default config location.

Note: As of Spring 3.0, Spring's EHCache support requires EHCache 1.3 or higher.

Since:
  1.1.1
Author:
  Dmitriy Kopylenko, Juergen Hoeller
See Also:
  `setConfigLocation(org.springframework.core.io.Resource)`, `setShared(boolean)`, `EhCacheFactoryBean`, `CacheManager`

Field Summary
`protected org.apache.commons.logging.Log` | `logger`

Constructor Summary
`EhCacheManagerFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`void` | `destroy()` Invoked by a BeanFactory on destruction of a singleton.
`net.sf.ehcache.CacheManager` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`java.lang.Class<? extends net.sf.ehcache.CacheManager>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` | `setCacheManagerName(java.lang.String cacheManagerName)` Set the name of the EHCache CacheManager (if a specific name is desired).
`void` | `setConfigLocation(Resource configLocation)` Set the location of the EHCache config file.
`void` | `setShared(boolean shared)` Set whether the EHCache CacheManager should be shared (as a singleton at the VM level) or independent (typically local within the application).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected final org.apache.commons.logging.Log logger

Constructor Detail

### EhCacheManagerFactoryBean

    public EhCacheManagerFactoryBean()

Method Detail

### setConfigLocation

    public void setConfigLocation(Resource configLocation)

  Set the location of the EHCache config file. A typical value is "/WEB-INF/ehcache.xml".

  Default is "ehcache.xml" in the root of the class path, or if not found, "ehcache-failsafe.xml" in the EHCache jar (default EHCache initialization).

  See Also:
    `CacheManager.create(java.io.InputStream)`, `CacheManager.CacheManager(java.io.InputStream)`

### setShared

    public void setShared(boolean shared)

  Set whether the EHCache CacheManager should be shared (as a singleton at the VM level) or independent (typically local within the application). Default is "false", creating an independent instance.

  See Also:
    `CacheManager.create()`, `CacheManager.CacheManager()`

### setCacheManagerName

    public void setCacheManagerName(java.lang.String cacheManagerName)

  Set the name of the EHCache CacheManager (if a specific name is desired).

  See Also:
    `CacheManager.setName(String)`

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws java.io.IOException,
                                   net.sf.ehcache.CacheException

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `java.io.IOException`
    `net.sf.ehcache.CacheException`

### getObject

    public net.sf.ehcache.CacheManager getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<net.sf.ehcache.CacheManager>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<? extends net.sf.ehcache.CacheManager> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<net.sf.ehcache.CacheManager>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<net.sf.ehcache.CacheManager>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### destroy

    public void destroy()

  Description copied from interface: `DisposableBean`
  Invoked by a BeanFactory on destruction of a singleton.

  Specified by:
    `destroy` in interface `DisposableBean`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD